﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Security.Cryptography;
using System.Text;
using System.IO;
using System.Windows.Forms;
namespace Šifrování
{
    class SynchCypher
    {

        public static string Encrypt(string originalString, string pass)
        {
            if (String.IsNullOrEmpty(originalString))
            {
                throw new ArgumentNullException
                       ("Zadejte vhodný řetězec k zašifrování!");
            }

            if (pass.Length != 8) // Algoritmus TripleDES používá 128 bitový šifrovací klíč
            {
                MessageBox.Show("Heslo musí být dlouhé 8 znaků");
                return "";
            }
            // Rozloží heslo na pole bajtů, kterým budou jednotlivé bloky textu šifrovány         
            byte[] bytes = ASCIIEncoding.Unicode.GetBytes(pass);
            // Vytvoří instanci třídy odvozené od třídy SymetricAlgorithm
            // představující daný symetrický šifrovací algoritmus.
            SymmetricAlgorithm cryptoProvider = SymmetricAlgorithm.Create("TripleDes");
            // Vytvoří datový proud do paměti do kterého budou ukládána výsledná data
            MemoryStream memoryStream = new MemoryStream();
            // Vytvoří šifrující datový proud k datům uchovaným v paměti
            CryptoStream cryptoStream = new CryptoStream(memoryStream,
                cryptoProvider.CreateEncryptor(bytes, bytes), CryptoStreamMode.Write);
            StreamWriter writer = new StreamWriter(cryptoStream);
            // Zašifruje bajty
            writer.Write(originalString);
            writer.Flush();
            cryptoStream.FlushFinalBlock();
            writer.Flush();

            return Convert.ToBase64String(memoryStream.GetBuffer(), 0, (int)memoryStream.Length);
        }

        public static string Decrypt(string cryptedString, string pass)
        {
            if (String.IsNullOrEmpty(cryptedString))
            {
                throw new ArgumentNullException
                   ("Zadejte řetězec, jež má být dekriptován!");
            }
            byte[] bytes = ASCIIEncoding.Unicode.GetBytes(pass);
            if (pass.Length != 8) // Algoritmus TripleDES používá 128 bitový šifrovací klíč
            {
                MessageBox.Show("Heslo musí být dlouhé 8 znaků");
                return "";
            }

            TripleDESCryptoServiceProvider cryptoProvider = new TripleDESCryptoServiceProvider();
            MemoryStream memoryStream = new MemoryStream
                    (Convert.FromBase64String(cryptedString));
            CryptoStream cryptoStream = new CryptoStream(memoryStream,
                cryptoProvider.CreateDecryptor(bytes, bytes), CryptoStreamMode.Read);
            StreamReader reader = new StreamReader(cryptoStream);
            return reader.ReadToEnd();
        }

    }
}
